<template>
  <div class="address">
    <div class="address__header">
      <AddressIcon class="address__icon" />
      <h2 class="address__title">آدرس شما</h2>
      <div class="address__actions">
        <ResponsiveComponent :break-point="450">
          <Button color="white" type="outlined" size="sm" v-if="!isCreating" @click.native="toggleMode">
            <template #icon>
              <AddIcon />
            </template>
            آدرس جدید
          </Button>
          <template #collapsed>
            <Button color="white" type="text" round size="sm" v-if="!isCreating" @click.native="toggleMode">
              <template #icon>
                <AddIcon />
              </template>
            </Button>
          </template>
        </ResponsiveComponent>
        <ResponsiveComponent :break-point="450">
          <Button color="white" type="outlined" size="sm" v-if="isCreating && addresses.length > 0" @click.native="toggleMode">
            <template #icon>
              <ListIcon />
            </template>
            انتخاب آدرس
          </Button>
          <template #collapsed>
            <Button color="white" type="text" round size="sm" v-if="isCreating && addresses.length > 0" @click.native="toggleMode">
              <template #icon>
                <ListIcon />
              </template>
            </Button>
          </template>
        </ResponsiveComponent>
      </div>
    </div>
    <div class="address__select-form" v-if="!isCreating">
      <Select id="address" :options="addressList" label="انتخاب آدرس" v-model="selectedAddress"/>
      <div class="not-selected" v-if="!selectedAddress.title">
        <EmptyIcon class="not-selected__icon" />
        <p class="not-selectd__text">لطفا یک آدرس را از لیست بالا انتخاب و یا یک آدرس جدید ایجاد کنید.</p>
      </div>
      <div class="selected" v-if="selectedAddress.title">
        <div class="displayer">
          <div class="displayer__row displayer__row--address">
            <p class="displayer__title">آدرس:</p>
            <p class="displayer__value">{{ selectedAddress.title }}</p>
          </div>
          <div class="displayer__row displayer__row--name">
            <p class="displayer__title">نام و نام خوانوادگی گیرنده:</p>
            <p class="displayer__value">{{ address.receiverName }}</p>
          </div>
          <div class="displayer__row displayer__row--phone">
            <p class="displayer__title">تلفن همراه گیرنده:</p>
            <p class="displayer__value">{{ address.phone }}</p>
          </div>
        </div>
      </div>
    </div>
    <AddressForm class="address__form" v-else light :self-create="false" :states="states" @change="onAddressChange" />
  </div>
</template>

<script>
import Button from "@/components/base/Button"
import Select from "@/components/base/Select"
import BackIcon from "@/assets/svgs/back.svg";
import AddIcon from "@/assets/svgs/add.svg";
import AddressIcon from "@/assets/svgs/location.svg";
import ClearIcon from "@/assets/svgs/remove_shopping_cart.svg";
import EmptyIcon from "@/assets/svgs/warning.svg";
import AddressForm from "@/components/dashboard/AddressForm";
import ResponsiveComponent from "@/components/base/ResponsiveComponent";
import ListIcon from "@/assets/svgs/view_list.svg"

export default {
  name: "Address",
  components: {
    Button,
    BackIcon,
    ClearIcon,
    EmptyIcon,
    AddressIcon,
    AddIcon,
    ListIcon,
    Select,
    AddressForm,
    ResponsiveComponent
  },
  props: {
    addresses: {
      type: Array,
      required: true
    },
    states: {
      type: Array,
      required: true
    }
  },
  data() {
    return {
      selectedAddress: {},
      isCreating: this.addresses.length > 0 ? false : true,
      creatingAddress: null
    }
  },
  computed: {
    addressList() {
      if (this.addresses) {
        return this.addresses.map(cur => {
          return { title: `${cur.state}، ${cur.city}، ${cur.address}`, id: cur.id };
        });
      }
      return [];
    },
    address() {
      return this.addresses.find(cur => cur.id === this.selectedAddress.id);
    }
  },
  methods: {
    onAddressChange(address) {
      this.creatingAddress = address;
    },
    toggleMode() {
      this.isCreating = !this.isCreating;
    },
    emitAddress() {
      if (this.isCreating) {
        this.$emit('change', this.creatingAddress);
      } else {
        this.$emit('change', this.selectedAddress.id);
      }
    }
  },
  watch: {
    selectedAddress() {
      this.emitAddress();
    },
    creatingAddress() {
      this.emitAddress();
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.address
  padding $lg $md
  @media only screen and (max-width 600px)
    padding $lg $sm
  &__header
    display flex
    align-items center
  &__actions
    margin-right auto
  &__title
    font-weight 400
    font-size 2.6rem
    @media only screen and (max-width 600px)
      font-size 2.3rem
  &__icon
    fill $white
    margin-left $sm
    @media only screen and (max-width 400px)
      display none
  &__select-form
    padding $lg 0
  &__form
    margin $md 0 0

.not-selected
  padding $lg 0 0
  display flex
  flex-direction column
  align-items center
  opacity 1
  text-align center
  &__text
    font-size $font-size
  &__icon
    margin-bottom $sm
    fill $white
    width 15rem
    height 15rem

.displayer
  margin  $lg 0 0
  &__row
    display flex
    @media only screen and (max-width 450px)
      flex-direction column
    &:not(:last-of-type)
      margin-bottom $sm
  &__title
    font-weight 500
  &__value
    margin-right $sm
    opacity .9
    color $primary
    @media only screen and (max-width 450px)
      margin-top $xsm
</style>